<?php
namespace Avaliacao\Entities;
use \Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class Questpadraval extends Base\Questpadraval
{

    const SEM_REGISTRO = 10;

    public static function consultaQuestPadrAval($nrorg, $nrcombquespadr){
        /** @var $objs \Avaliacao\Entities\Base\Questpadraval */
        $objs = self::getObjectByWhere(
            'NRORG = ? AND NRCOMBQUESTPADR = ?',
            array(
                $nrorg,
                $nrcombquespadr,
            )
            //'ORDER BY NRORDEQUESTPADR'
        );
        return $objs;
    }

    /**
     * @static
     * @param $nrorg
     * @param $nrcomquestpadr
     *
     * @return bool|mixed
     */

    public static function retornaQuestoesPorCombinacao($nrorg, $nrcombquestpadr){
        try {
            $questoes = self::getObjectsByWhere(
                'NRORG = ? AND NRCOMBQUESTPADR = ?',
                array(
                    $nrorg,
                    $nrcombquestpadr,
                )
            );

            return is_array($questoes) ? $questoes : false;
        } catch (\Exception $e) {
            tk_warning('Erro desconhecido ', $e->getMessage());
            return false;
        }
    }

    /**
     * @static
     * @param $nrorg
     * @param $nrquestpadraval
     *
     * @return bool|mixed
     */
    public static function retornaQuestaoPadrao($nrorg, $nrquestpadraval){
        $questao = Questpadraval::retornQuestaoPadrao($nrorg, $nrquestpadraval);
        return is_object($questao) ? $questao : false;
    }


    /**
     * @static
     * @param $nrorg
     * @param $combi_origem
     * @param $combi_destino
     * @param $operador
     * @return bool|int
     * @throws Exception
     */
    public static function copiaQuestoesDaCombinacao($nrorg, $combi_origem, $combi_destino, $operador){
        $origem  = self::retornaQuestoesPorCombinacao($nrorg, $combi_origem);
        $destino = self::retornaQuestoesPorCombinacao($nrorg, $combi_destino);

        $lista = array();
        if ($destino !== false) {
            /** @var $questao \Avaliacao\Entities\Base\Questpadraval */
            foreach ($destino as $questao) {
                $lista[] = $questao->getNrquestao();
            }
        }

        try{
            if ($origem !== false) {
                $count = 0;
                foreach ($origem as $questao) {
                    if (!in_array($questao->getNrquestao(), $lista)) {
                        $new = new self;
                        $new->setNrquestpadraval(NovoCodigo::geraCodigo($nrorg, 'QUESTPADRAVAL', 10));
                        $new->setNrorg($nrorg);
                        $new->setNrcombquestpadr($combi_destino);
                        $new->setNrquestao($questao->getNrquestao());
                        $new->setNrnivelquestao($questao->getNrnivelquestao());
                        $new->setVrnotaquestpadr($questao->getVrnotaquestpadr());
                        $new->setIdsortquestpadr($questao->getIdsortquestpadr());
                        $new->setDsquestpadraval($questao->getDsquestpadraval());
                        $new->setNrordequestpadr($questao->getNrordequestpadr());
                        $new->setDtinclusao(now());
                        $new->setDtultatu(now());
                        $new->setNrorginclusao($nrorg);
                        $new->setCdoperinclusao($operador);
                        $new->setNrorgultatu($nrorg);
                        $new->setCdoperultatu($operador);
                        $new->setNragrupquestpad($questao->getNragrupquestpad());
                        $new->setIdativo($questao->getIdativo());

                        $new->persist();
                        $count++;
                    };
                }
            } else {
                return false;
            }
        } catch(\Exception $e){
            throw new \Exception('Erro desconhecido'.$e->getMessage());
        }
        return $count;
    }

    public static function retornaQuestPadrAval($nrorg, $nrcombquestpadr){
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND NRCOMBQUESTPADR = ?',
            array(
                $nrorg,
                $nrcombquestpadr,
            ),
            'NRORDEQUESTPADR'
        );

        return $objs;
    }




    /**
     * @static
     * @param $nrorg
     * @param $nrquestpadraval
     * @return mixed
     */
    public static function retornQuestaoPadrao($nrorg, $nrquestpadraval){
        try {
            $questao = self::getObjectByWhere(
                'NRORG = ? AND NRQUESTPADRAVAL = ?',
                array(
                    $nrorg,
                    $nrquestpadraval,
                )
            );

            return $questao;
        } catch (\Exception $e) {
            tk_warning('Erro desconhecido ', $e->getMessage());
            return false;
        }
    }

    public static function consultaQuestoesPadraval($nrorg, $nrpadravaliacao){
        try {
            $objQuestPadraval = self::getObjectsByWhere(
                'NRORG = ? AND NRPADRAVALIACAO = ?',
                array(
                    $nrorg,
                    $nrpadravaliacao,
                )
            );

            return $objQuestPadraval;
        } catch (\Exception $e) {
            tk_warning('Erro desconhecido ', $e->getMessage());
            return false;
        }
    }

    public static function insereQuestoesPadraval($registro, $nrpadravaliacao, $cdoperador){
        $questPadraval = new self;
        /** @var $registro \Avaliacao\Entities\Questpadraval */
        $questPadraval->setNrorg($registro->getNrorg());
        $questPadraval->setNrcombquestpadr($registro->getNrcombquestpadr());
        $questPadraval->setNrquestao($registro->getNrquestao());
        $questPadraval->setNrnivelquestao($registro->getNrnivelquestao());
        $questPadraval->setVrnotaquestpadr($registro->getVrnotaquestpadr());
        $questPadraval->setIdsortquestpadr($registro->getIdsortquestpadr());
        $questPadraval->setDsquestpadraval($registro->getDsquestpadraval());
        $questPadraval->setNrordequestpadr($registro->getNrordequestpadr());
        $questPadraval->setDtinclusao(DateUtil::getDataAtual());
        $questPadraval->setDtultatu(DateUtil::getDataAtual());
        $questPadraval->setNrorginclusao($registro->getNrorginclusao());
        $questPadraval->setCdoperinclusao($cdoperador);
        $questPadraval->setNrorgultatu($registro->getNrorgultatu());
        $questPadraval->setCdoperultatu($cdoperador);
        $questPadraval->setNragrupquestpad($registro->getNragrupquestpad());
        $questPadraval->setIdativo($registro->getIdativo());
        $questPadraval->setNrtemaanalise($registro->getNrtemaanalise());
        $questPadraval->setTxcomplementoquestao($registro->getTxcomplementoquestao());
        $questPadraval->setNrquestpadraval(NovoCodigo::geraCodigo($registro->getNrorg(), 'QUESTPADRAVAL'));
        $questPadraval->setNrpadravaliacao($nrpadravaliacao);
        $questPadraval->persist();
        Registry::getEntityManager()->flush();
    }

}